08.onentercontext {
	fighttext='';
}

08.ontext {
	fighttext+=text;
}

08.onleavecontext {
	startfight();
}

08_08.onleavecontext, 08_09.onleavecontext, 08_10.onleavecontext, 08_12.onleavecontext {
	endfight();
}

08_11.onentercontext {
	fleetext = '';
}

08_11.ontext {
	fleetext += text;
}

08_11.onleavecontext {
	onflee(); endfight();
}

08_13.onleavecontext {	# Not updating persona #
	cleanup();
}

startfight {
	sleeping = 0;
	fighting++;
								
	if (fighting == 1)
	{	
		achannel = 1 - achannel;
		fadeinsound('fight', achannel, 100, 200);				
	}
				
	# Strip out weapon usage #

	if (fighttext ~= ', using ')
	{
		wppos = (find(fighttext, ', using '));					

		fighttext = substr(fighttext, 0, wppos);
	}

	# Get name of attacker #							

	if ((substr(fighttext, 0, 10)) == 'You attack')
	{
		if (((wordat(fighttext, 2)) == 'the') || ((wordat(fighttext, 2)) == 'a'))
			{ opponent = wordat(fighttext, (-1 + words(fighttext))); }
		#else
			{ opponent = wordat(fighttext, 2); }#
	}
	else
	{					
		if (((substr(fighttext, 0, 4)) == 'The ') || ((substr(fighttext, 0, 2)) == 'A '))
		{
			opponent = wordat(fighttext, 1);

			# Need a loop to skip letters until a non-adjective is hit, really #

			if ((opponent == 'old') || (opponent == 'female') || (opponent == 'male'))
				{ opponent = wordat(fighttext, 2); }
		}
		#else											
			{ opponent = wordat(fighttext, 0); }#
	}								

	if ((opponent == 'Someone') || (opponent == 'Something'))
		{ opponent = ''; };
}

endfight {
	if (fighting > 0)
	{									
		if (fighting == 1)
		{
			fadeoutsound(achannel, 100);

			if (context == '08 11')
			{
				# Fleeing... #

				if (autoreattack)					
					{ doreattack(); }				
			}
			else
				{ opponent = ''; }
		}

		fighting--;
		sleeping = 0;
	};
}

onflee {
	if ((substr(fleetext, 0, 3)) == 'You')
		{ fleedir = ''; opponent = ''; }
	else
	{
		if (fleetext ~= 'tried')
			{ fleedir = ''; }
		else
			{ fleedir = wordat(fleetext, (-1 + words(fleetext))); }

		# If mobile was invisible on attack, then try and recapture it #

		if (opponent == '')
		{					
			if (((substr(fleetext, 0, 4)) == 'The ') || ((substr(fleetext, 0, 2)) == 'A '))
			{
				fopponent = wordat(fleetext, 1);

				if ((fopponent == 'old') || (fopponent == 'female') || (fopponent == 'male'))
					{ fopponent = wordat(fleetext, 2); }
			}
			#else											
				{ fopponent = wordat(fleetext, 0); }#

			if ((fopponent != 'Someone') && (fopponent != 'Something'))
				{ opponent = fopponent; }
		}
	};
}

doreattack {			
	if (opponent)
	{
		opp = opponent;

		if (reattackwp)
			{ opp += (' f ' + reattackwp); }
				
		if (fleedir == '')
			{ send('k ' + opp); }
		else
		{
			send(fleedir + ('.k ' + opp));
			fleedir = '';
		}
	}

	opponent = 'mob';
}

togglereattack {
	if (initialised)
	{
		if (autoreattack)
		{
			autoreattack = '';					

			imessage('AUTOREATTACK is now OFF');
		}
		else
		{
			autoreattack = 'Y';

			if (reattackwp)
				{ imessage(('AUTOREATTACK is now ON, using "' + reattackwp) + '"'); }
			else
				{ imessage('AUTOREATTACK is now ON (no weapon specified)'); }
		}

		update('mainpane');
	}
	else
		autoreattack = '';
}