12_08_01.onleavecontext {
	sta		= int(wordat(sstring, 0));	stamax		= int(wordat(sstring, 1));
	effstr	= int(wordat(sstring, 2));	str			= int(wordat(sstring, 3));
	effdex	= int(wordat(sstring, 4));	dex			= int(wordat(sstring, 5));
	mag		= int(wordat(sstring, 6));	magmax		= int(wordat(sstring, 7));
	score	= wordat(sstring, 8);		blind		= wordat(sstring, 9);
	deaf	= wordat(sstring, 10);		crippled	= wordat(sstring, 11);
	dumb	= wordat(sstring, 12);		ttreset		= int(wordat(sstring, 13));
	weather	= wordat(sstring, 14);

	updatestatus();
	popoutput();
}

12.onentercontext {
	setoutput('main');
	hidinginfo = 0;	

	if (context == '12')
	{	
		infotext = '';
		if (pendinginfo && (inforef == 0))
		{
			hidinginfo = 1;		
			pushoutput('');
		}
		else
			feiref = 0;

		inforef++;
	}
}

12.ondefercontext {
	if (hidinginfo)
	{
		# Abort hiding info as output is nested #

		popoutput('');
		print(infotext, context);

		hidinginfo = 0;		
	}
}

12.ontext {
	if ((context == '12') && (inforef == 1))
		infotext += text;
}

12.onendline {
	if ((context == '12') && (inforef == 1))
		infotext += CR;
}

12.onleavecontext {				
	# Extract useful information here... #

	if (context == '12')
	{
		sv_info = 0;
		if ((infotext ~= 'alive') && (infotext ~= 'dead'))
		{											
			# Test for survivor information... #
					
			if (words(infotext) == 4)
			{												
				oldsurvivors = survivors;

				survivors = int(wordat(infotext, 0));
				mobkilled = int(wordat(infotext, 2));

				if (oldsurvivors != survivors)
				{		
					# Update survivors display... #					

					if (isvisible('infopane'))
					{
						settext('survivors', (string(survivors) + ' / ') + (mobkilled + survivors));	
						update('survivors');
					}
				}

				sv_info = 1;
			}
		}
			
		if (hidinginfo)
		{	
			hidinginfo = 0;

			popoutput();

			if (sv_info && pendinginfo)
			{								
				suppresscr(); # A new line is sent after this context ends, so suppress it #
				
				pendinginfo = 0;
			}			
			else
			{			
				# We hid the wrong info, so display it! #
				
				print(infotext, context);
			}
		}

		inforef--;

		if (inforef < 0)
			inforef = 0;
	}	
}

disenableteam {
	# -- FETEAM function ------------------------- #

	if (teamed == 0)
	{ 
		disablewindow('check_team');
		hidewindow('teampane');

		unauto('feteam');
	}
	else						
	{
		enablewindow('check_team');
		auto('feteam', 15, 'sendinterrupt(\'feteam\');');
	};
}

setteaminfo {
	# -- FETEAM function ------------------------- #

	if ((words(fetinfo)) < 4)
	{							
		# Not in a team, so cancel team info requests #

		teamed = 0;
		disenableteam();
	}
	else
	{
		# Get team number, kills, score and captain #
			
		tmno = (wordat(fetinfo, 0));						
		tmkills = (wordat(fetinfo, 1));						
		tmscore = (wordat(fetinfo, 2));						
		tmcaptain = (wordat(fetinfo, 3));
							
		# Extract respawn room (comes after '|') #

		restartoffset = (find(fetinfo, '| '));
		settext('teamstart', left(fetinfo, (restartoffset + 2)));					
							
		# Calculate member count #

		tmmembers = (((words(fetinfo)) - (words(gettext('teamstart')))) - 5);
		settext('teammembers', tmmembers);

		settext('team', tmno);
		settext('teamscore', (((('' + tmscore) + ' (') + tmkills) + ')'));
		settext('teamcaptain', tmcaptain);
	};
}

updateplayercount {
	# -- FEWHO function (player count) --------- #

	if (playercount != oldplayercount)
	{							
		settext('players', playercount);
		update('players');

		oldplayercount = playercount;
	};
}

processmapline {
	# -- FEMAP function ------------------------ #

	if (mapline == 1)
	{
		mapicon = wordat(maptext, 0); iconid = 'map_up'; setmapicon();
	}

	if (mapline == 3)
	{
		mapicon = wordat(maptext, 0); iconid = 'map_nw'; setmapicon();
		mapicon = wordat(maptext, 1); iconid = 'map_n'; setmapicon();
		mapicon = wordat(maptext, 2); iconid = 'map_ne'; setmapicon();
	}

	if (mapline == 5)
	{
		mapicon = wordat(maptext, 0); iconid = 'map_w'; setmapicon();							
		mapicon = wordat(maptext, 1); iconid = 'map_e'; setmapicon();
	}

	if (mapline == 7)
	{
		mapicon = wordat(maptext, 0); iconid = 'map_sw'; setmapicon();
		mapicon = wordat(maptext, 1); iconid = 'map_s'; setmapicon();
		mapicon = wordat(maptext, 2); iconid = 'map_se'; setmapicon();
	}

	if (mapline == 9)
	{
		mapicon = wordat(maptext, 0); iconid = 'map_down'; setmapicon();
	}

	maptext = '';
	mapline++;
}

setmapicon {
	# -- FEMAP function ------------------------ #

	imageid = 'map_dunno';
	imageid = switch(mapicon, '## => map_wall,	   ~. => map_beach,
							   == => map_bed,	   +  => map_crypt,
							   oo => map_dark,	   /  => map_none,
							   ?? => map_dunno,	   {} => map_garden,
							   ++ => map_grave,	   .^ => map_hill,
							   __ => map_meadow,   o  => map_fring,
							   ^^ => map_mountain, OO => map_olive,
							   -  => map_path,	   PP => map_pine,
							   ~  => map_river,    #= => map_railway,
							   -- => map_road,	   .. => map_room,
							   ~~ => map_sea,	   || => map_shaft,
							   *  => map_costar,   .: => map_step,
							   () => map_swamp,	   TT => map_forest,
							   [] => map_yard,	   %% => map_blizzard,
							   -_ => map_rockypth, %^ => map_snowymtn,
							   ^% => map_snowymtn');

	setimage(iconid, imageid);
}

updateicons {
	status_index = 0;

	if (weather != 'F')
	{
		oldweather = weather;

		wimage = switch(weather, 'S => snow, B => blizzard, R => rain, T => storm, C => cloudy, O => overcast');
		setimage(('status_' + status_index), wimage);

		wtip = switch(weather, 'S => It\'s snowing!, B => Blizzard!, R => It\'s raining!, T => It\'s stormy!, C => It\'s cloudy!, O => It\'s overcast!');
		settext(('status_' + status_index), wtip);

		status_index++;
	}

	if (blind == 'Y')
	{
		setimage(('status_' + status_index), 'aff_blinded');						
		settext(('status_' + status_index), 'Blinded');
		status_index++;
		
		showwindow('blindedicon');
	}
	else	
		hidewindow('blindedicon');	

	if (deaf == 'Y')
	{
		setimage(('status_' + status_index), 'aff_deaf');
		settext(('status_' + status_index), 'Deafened');
		status_index++;
	}

	if (dumb == 'Y')
	{
		setimage(('status_' + status_index), 'aff_dumb');
		settext(('status_' + status_index), 'Dumb');
		status_index++;
	}

	if (crippled == 'Y')
	{
		setimage(('status_' + status_index), 'aff_crippled');
		settext(('status_' + status_index), 'Crippled');
		status_index++;
	}					

	if (status_index == 5)
	{
		showwindow('status_0'); showwindow('status_1'); showwindow('status_2'); showwindow('status_3'); showwindow('status_4');
	}
	else
	{
		if (status_index == 4)
		{
			showwindow('status_0'); showwindow('status_1'); showwindow('status_2'); showwindow('status_3'); hidewindow('status_4');
		}
		else
		{
			if (status_index == 3)
			{
				showwindow('status_0'); showwindow('status_1'); showwindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
			}
			else
			{
				if (status_index == 2)
				{
					showwindow('status_0'); showwindow('status_1'); hidewindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
				}
				else
				{
					if (status_index == 1)
					{
						showwindow('status_0'); hidewindow('status_1'); hidewindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
					}
					else
					{
						hidewindow('status_0'); hidewindow('status_1'); hidewindow('status_2'); hidewindow('status_3'); hidewindow('status_4');
					}
				}
			}
		}
	};
}

updatescore {					
	sc = int(score);
																		
	if (sc != lastscore)
	{												
		settext('score', fstring(sc));

		if ((startscore < 0) && (sc > 0))
			{ startscore = sc; }
										
		if (startscore == sc)
		{
			settextcolour('resetscore', '#ffffff');
			settext('resetscore', '(-)');
		}
		else
		{			
			if (sc > startscore)
			{	
				scdiff = (sc - startscore);	
								
				settextcolour('resetscore', '#77ff77');	
				settext('resetscore', ('(+' + fstring(scdiff) + ')'));								
			}
			else
			{
				scdiff = (startscore - sc);

				settextcolour('resetscore', '#ff7777');	
				settext('resetscore', ('(-' + fstring(scdiff) + ')'));	
			}
		}
						
		lastscore = sc;	
	}
}

updatestatus {
	updatescore();
												
	settext('sta', ('STA: ' + sta) + (' (' + stamax) + ')');
	settext('str', ('STR: ' + effstr) + (' (' + str) + ')');
	settext('dex', ('DEX: ' + effdex) + (' (' + dex) + ')');

	if (mag == 0)
		settext('mag', 'MAG: - (-)');
	else
		settext('mag', ('MAG: ' + mag) + (' (' + magmax) + ')');

	updateicons();

	oldsta = sta;													
	sta = ceiling(stamax, sta);

	oldmag = mag;
	mag = ceiling(magmax, mag);
					
	oldstr = str;
	str = floor(effstr, str);

	olddex = dex;
	dex = floor(effdex, dex);

	resetlabel = (string(ttreset) + ' minutes to reset');
	settext('reseticon', resetlabel);
	settext('resetfader', resetlabel);

	ttreset = ceiling(105, ttreset);

	setfaderrange('stafader', stamax);
	setfadervalue('stafader', stamax - sta);
	setfaderrange('magfader', magmax);
	setfadervalue('magfader', magmax - mag);
	setfaderrange('strfader', str);
	setfadervalue('strfader', str - effstr);
	setfaderrange('dexfader', dex);
	setfadervalue('dexfader', dex - effdex);
	setfaderrange('resetfader', 105);
	setfadervalue('resetfader', 105 - ttreset);										
					
	sta = oldsta;
	mag = oldmag;
	str = oldstr;
	dex = olddex;

	considerdreamword();				
}

processfeinv {					
	if (feitext == '========')
		feimode='inventory';
	else
	{
		if (feitext == '--')
		{
			blinded = 1;
			showwindow('blindedicon');
		}
		else
		{
			if (feitext == 'oo')
			{
				dark = 1;
				showwindow('darkicon');
			}
			else
			{
				appenditem(feimode, feitext);

				colour = '';
				if (tlist ~= feitext)
					colour = '#66ffff';
				else
				{
					if (tklist ~= feitext)
						colour = '#00ffff';
					else
					{
						if (ntlist ~= feitext)
							colour = '#00cccc';
						else
						{
							if (mlist ~= feitext)
								colour = '#ff00ff';
						}
					}
				}

				if (colour != '')
					setitemcolour(feimode, feitext, colour);
			}
		}
	}

	feitext='';					
}