startup {
	if (initialised == 0)
	{	
		whoinprogress = 0; wizinfo = 0; reroll = 0; fighting = 0; queuesv = 0; tcounter = 999; feiref = 0;
		qutoresponse = ''; lastcmd = ''; fleedir = ''; autoreattack = ''; reattackwp = '';
		autoresleep = 1; filter_tell = 1; blinded = 0; dark = 0; inforef = 0;

		quoting = false;
				
		opponent = 'mob';
		ccmkey = 'default';

		teamed = 0;				
		disenableteam();

		if (privs < 2)
			hook('hint', 'Elizabethan tearoom', 'showhint();');
		else
		{
			if (privs == 2)
				hook('hint', 'Wizzes\' room', 'showhint();');
			else
				hook('hint', 'Control room', 'showhint();');
		}

		achannel = 0; sfxchannel = 0;
		sendinterrupt('FES.FEI.FEW');				
				
		if (nologging == 0)
		{ 					
			beginlog();
			logging = 1;
		}
								
		blind = 'N'; deaf = 'N'; crippled = 'N'; dumb = 'N'; weather = 'F'; oldweather = 'F';
		swampdir = 'ZW';

		sleeping = 0;
		snooping = 0;
		initialised = 1;

		automap = 0;
		setautomap();
		setautowho();
				
		pendinginfo = 0;
		startscore = -1;

		if (isvisible('miscpane') && isvisible('infopane'))
		{			
			pendinginfo = 1;						
			sendinterrupt('SV');						
		}

		if (isvisible('invpane') || isvisible('outsidepane'))
			do_fei = 1;

		auto('fes', 10, 'getinfo();');				
	};	
}

showhint {
	unhook('hint');
			
	if (privs > 0)
		{ message('NOTE:	REROLL <stamina> is available for personae with 0 points.'); }
	else
		{ message('NOTE:	Please be aware that the automap is not available for guests.'); };

	message('	AUTORESPONSE <msg> enables auto-response (omit <msg> to disable).');
	message('	AUTOREATTACK [ON/OFF/<weapon>/NONE] configures auto re-attack (mobiles only!).');
}

getinfo {	
	if ((initialised == 1) && (fighting == 0))
	{		
		if ((isvisible('miscpane')) && (isvisible('infopane')))
		{
			if ((sdesc == 'Elizabethan tearoom') || (timeout > 30))
			{						
				if (!sleeping)
				{
					if (pendinginfo == 0)
					{
						pendinginfo = 1;
						sendinterrupt('SV');
					}
				}
			}
			else
				queuesv = 1; 					
		}

		sendinterrupt('FES');
	}
}

setautowho {
	if (initialised == 1)
	{
		if ((isvisible('whopane')) && (isvisible('infopane')))
			auto('few', 10, 'if (initialised && (fighting == 0)) { sendinterrupt(\'FEW\'); };');
		else
			unauto('few');
	}
	else
		unauto('few');
}

setautomap {
	if ((initialised == 1) && (privs > 0))
	{
		if ((isvisible('mappane')) && (isvisible('infopane')))
		{
			automap = 1;
			sendinterrupt('AUTO MAP.MAP');					
		}
		else								
		{
			if (automap)
			{
				sendinterrupt('UNAUTO MAP');
				automap = 0;
			}
		}
	}
}

setinventory {
	if (whoinprogress == 0)
	{
		if (((isvisible('invpane')) || (isvisible('outsidepane'))) && (isvisible('infopane')))
			sendinterrupt('FEI');
	}
}

setscore {
	if (whoinprogress == 0)
		sendinterrupt('FES');	
}

resetstatus {
	lastscore = score; score = '-'; startscore = 0;
	dreamword = ''; fleedir = ''; autoreattack = ''; reattackwp = '';
	
	opponent = 'mob';	
			
	hidewindow('status_0');
	hidewindow('status_1');
	hidewindow('status_2');
	hidewindow('status_3');

	automap = 0; queuesv = 0; sleeping = 0; snooping = 0; pendinginfo = 0; wizinfo = 0;
	resleep = 0; promptref = 0; tcounter = 999; feiref = 0; inforef = 0;
	do_fei = 1; autoresleep = 1;
	quoting = false;

	str = 100; dex = 100; stamax = 100; magmax = 100;
	effstr = 0; effdex = 0; sta = 0; mag = 0;
	blind = 'N'; deaf = 'N'; crippled = 'N'; dumb = 'N'; weather = 'F'; oldweather = 'F';
			
	oldsurvivors = 1; survivors = 0;
	oldplayercount = 1; playercount = 1;			

	swampdir = 'ZW';
	ttreset = 0;

	unhook('hint');
	unhook('alert');

	updatestatus();
	updateicons();

	startscore = -1;
}

cleanup {
	if ((getoutput()) == 'main')
	{
		afk = 0;				

		stopsound(0);
		stopsound(1);

		if (logging)
		{
			endlog();
			logging = 0;
		}			

		clear('outside');
		clear('inventory');
		clear('fewho');

		teamed = 0;				
		disenableteam();

		setimage('map_up', 'map_none'); setimage('map_down', 'map_none');
		setimage('map_nw', 'map_none'); setimage('map_n', 'map_none'); setimage('map_ne', 'map_none');
		setimage('map_w', 'map_none'); setimage('map_e', 'map_none');
		setimage('map_sw', 'map_none'); setimage('map_s', 'map_none'); setimage('map_se', 'map_none');

		settext('players', '-');
		settext('survivors', '- / -');			

		resetstatus();						
				
		setautowho();
		unauto('fes');					

		resetmudstack();
		initialised = 0;
	}
}

name_filter.onsubmit {
	filter_pname = (wordat(text, 0));

	if (filter_pname == '')
	{
		filter_persona = 0;
		uncheck('ctoggle_persona');	
	}
	else
		{ filter_persona = 1; }													

	setfocus('commpane');
}

toggleroom {
	if (isvisible('outsidepane'))
		{ hidewindow('outsidepane'); uncheck('check_room'); }							
	else
	{
		showwindow('outsidepane');
		check('check_room');

		if (initialised == 1)
		{
			sendinterrupt('FEI');
			do_fei=1;
		}
	}

	update('outsidepane');
}

toggleinv {
	if (isvisible('invpane'))
		{ hidewindow('invpane'); uncheck('check_inv'); }							
	else
	{
		showwindow('invpane');
		check('check_inv');

		if (initialised == 1)
		{
			sendinterrupt('FEI');
			do_fei=1;
		}
	}

	update('invpane');
}

togglemap {
	if (isvisible('mappane'))
		{ hidewindow('mappane'); uncheck('check_map'); }							
	else
		{ showwindow('mappane'); check('check_map'); }

	setautomap();
	update('mappane');
}

togglewho {							
	if (isvisible('whopane'))
		{ hidewindow('whopane'); uncheck('check_who'); }							
	else
	{
		showwindow('whopane');
		check('check_who');
									
		if (initialised == 1)
			sendinterrupt('FEW');
	}

	setautowho();
	update('whopane');
}

toggleteam {
	if (teamed == 1)
	{
		if (isvisible('teampane'))
			{ hidewindow('teampane'); uncheck('check_team'); }							
		else
			{ showwindow('teampane'); check('check_team'); sendinterrupt('FETEAM'); }

		update('teampane');
	};
}

togglestatus {
	if (isvisible('infopane'))
		{ hidewindow('infopane'); uncheck('check_status'); }							
	else
		{ showwindow('infopane'); check('check_status'); }

	update('infopane');

	setautomap();
	setautowho();
}

search {
	if (focus == 'cmdline')
	{
		# Search main document for text in command line #

		findtext('main', (gettext('cmdline')));
	}
	else
	{
		# Search in the focus window instead #

		findtext(focus, (gettext('cmdline')));
	};
}